
function [startp,endp] = MMGetborders(t,y,titleName,knownFrame)
    global yestoall
    
    if nargin<4
        knownFrame = 0;
    else
        if yestoall
            startp =    knownFrame(1);
            endp =      knownFrame(2);
        else
            h=figure('Name','Previous frame');
            plot(t,y,'-','Linewidth',2);
            hold on
            plot([t(knownFrame(1)) t(knownFrame(1))],get(gca,'YLim'),'k')
            plot([t(knownFrame(2)) t(knownFrame(2))],get(gca,'YLim'),'k')
            hold off

            choice = questdlg('Would you like to keep this frame?', ...
                'Warning', ...
                'Yes','Yes to all','No thank you','Yes');
            if strcmp(choice,'Yes')
                startp =    knownFrame(1);
                endp =      knownFrame(2);
            elseif strcmp(choice,'Yes to all')
                startp =    knownFrame(1);
                endp =      knownFrame(2);
                yestoall=1;
            elseif strcmp(choice,'No thank you')
                knownFrame=0;
            elseif strcmp(choice,'Cancel')
                error('MMGetborders:WindowCancel','Window deleted.');
            end
            close(h)
        end
    end
    
    if knownFrame == 0
        h2=figure('Name','Choose your starting and end point');
        set(gcf,'DefaultAxesColorOrder',[1 0 0;0 1 0;0 0 1])
        plo=plot(t,y,'-','Linewidth',2);
        %leg=legend(plo,titlename);
        %set(leg,'FontSize',16);
        title(titleName);
        grid on;

        
        hold on
        TEMP=ginput(1);
        startp=find(t>TEMP(1),1);
        plot([t(startp) t(startp)],get(gca,'YLim'),'k')
        TEMP=ginput(1);
        endp=find(t>TEMP(1),1);
        plot([t(endp) t(endp)],get(gca,'YLim'),'k')
        hold off
        close(h2)

    end
    fprintf('> %s: Start point %d; End point %d... \n',titleName,startp,endp)
end