function [param,fitinfo] = MMNumeric(tdata,ydata,startp,endp,fitinfo)


global LamFun;

if fitinfo.flags.dt_n && fitinfo.flags.s0_n
    mStart=[max(ydata(startp:endp)) fitinfo.km_n fitinfo.vm_n round(-tdata(startp))];
elseif fitinfo.flags.dt_n && ~fitinfo.flags.s0_n
    mStart=[fitinfo.s0_n fitinfo.km_n fitinfo.vm_n   round(-tdata(startp))];
elseif ~fitinfo.flags.dt_n && fitinfo.flags.s0_n
    mStart=[max(ydata(startp:endp)) fitinfo.km_n fitinfo.vm_n fitinfo.dt_n];
elseif ~fitinfo.flags.dt_n && ~fitinfo.flags.s0_n 
    mStart=[fitinfo.s0_n fitinfo.km_n fitinfo.vm_n fitinfo.dt_n];
end

mLower     = [max(ydata(startp:endp))/2 0.1 0 -max(tdata)];
mUpper     = [max(ydata(startp:endp))*10 10^5 10^6 max(tdata)];


if fitinfo.flags.expleak
    LamFun=@(m,t)(m(1)-m(2).*lambertw(m(1)/m(2).*exp( (m(1)-m(3).*...
    (t+m(4)) ) ./m(2)) ) ) .*exp(-m(5).*t);
    mStart = [mStart fitinfo.kl];
    mLower = [mLower 0];
    mUpper = [mUpper Inf];
elseif fitinfo.flags.linleak
    LamFun=@(m,t)(m(1)-m(2).*lambertw(m(1)/m(2).*exp( (m(1)-m(3).*...
    (t+m(4)) ) ./m(2)) ) -t.*m(5));
    mStart = [mStart fitinfo.l];
    mLower = [mLower 0];
    mUpper = [mUpper Inf];
else
    LamFun=@(m,t)(m(1)-m(2).*lambertw(m(1)/m(2).*exp( (m(1)-m(3).*...
    (t+m(4)) ) ./m(2)) ) );
end

fitinfo.formula=func2str(LamFun);
fitinfo.start_param=['[',sprintf('%d,',mStart(1:end-1)),sprintf('%d]',mStart(end))];
fitinfo.lower_limit=['[',sprintf('%d,',mLower(1:end-1)),sprintf('%d]',mLower(end))];
fitinfo.upper_limit=['[',sprintf('%d,',mUpper(1:end-1)),sprintf('%d]',mUpper(end))];

v_TolX=10^-10;
v_TolFun=10^-10;
v_MaxFunEvals=1000;
v_MaxIter=10000;

fitinfo.TolX=v_TolX;
fitinfo.TolFun=v_TolFun;
fitinfo.MaxFunEvals=v_MaxFunEvals;
fitinfo.MaxIter=v_MaxIter;

% fitoptions=optimset('Display','off','TolX',v_TolX,'TolFun',v_TolFun,...
%          'MaxFunEvals',v_MaxFunEvals,'MaxIter',v_MaxIter,'PlotFcns',...
%          @optimplotfval,'Algorithm',fitinfo.fitmethod);
fitoptions=optimoptions('lsqcurvefit','Display','off','TolX',v_TolX,'TolFun',v_TolFun,...
         'MaxFunEvals',v_MaxFunEvals,'MaxIter',v_MaxIter,'PlotFcns',...
         @optimplotfval,'Algorithm',fitinfo.fitmethod);

if strcmp(fitinfo.fitmethod,'trust-region-reflective')
    [para,resnorm,~,exitflag,~] = lsqcurvefit(LamFun,mStart,...
        tdata(startp:endp),ydata(startp:endp),mLower,mUpper,fitoptions);
else
     [para,resnorm,~,exitflag,~] = lsqcurvefit(LamFun,mStart,...
        tdata(startp:endp),ydata(startp:endp),[],[],fitoptions);
end

fitinfo.flags.exitflag=exitflag;
if size(para,1)>1
    para=para';
end
param=[para,resnorm];

fitinfo=MMAfterfit(tdata,ydata,param,fitinfo);
                  
end

